###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define buildlargesmp 1
%define buildxen 1
%define kernel_version 2.6.9-55.0.2.EL.XOS.1
%define subversion 72

%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif 

%ifnarch i686
%define buildhugemem 0
%endif 

%ifnarch x86_64 ia64 ppc64
%define buildlargesmp 0
%endif

Name: GFS-kernel
Version: 2.6.9
Release: 72.2.0.2.XOS.1
License: GPL
Group: System Environment/Kernel
Summary: GFS-kernel - The Global File System kernel modules
BuildRequires: gulm-devel dlm-devel dlm-kernheaders
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: dlm-kernel

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: dlm-kernel-smp
%endif

%if %{buildhugemem}
BuildRequires: kernel-hugemem-devel = %{kernel_version}
BuildRequires: dlm-kernel-hugemem
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
BuildRequires: dlm-kernel-largesmp
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: dlm-kernel-xenU
%endif

BuildRequires: dlm-kernheaders >= 2.6.9
BuildRequires: cman-kernheaders >= 2.6.9
Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: gfs-kernel-%{version}-%{subversion}.tar.gz
Patch0: gfs-bz243146-inode-corruption.patch
Patch9: gfs-kernel-2.6.9-72-types.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.

%package -n GFS-kernheaders
Group: Development/System
Summary: GFS kernel header files

%description -n GFS-kernheaders
The GFS kernel headers are used by the GFS tool set for compilation.

%if %{buildsmp}
%package -n GFS-kernel-smp
Group: System Environment/Kernel
Summary: GFS-kernel-smp - The Global File System kernel modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
%description -n GFS-kernel-smp
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildhugemem}
%package -n GFS-kernel-hugemem
Group: System Environment/Kernel
Summary: GFS-kernel-hugemem - The Global File System kernel modules
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-hugemem
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildlargesmp}
%package -n GFS-kernel-largesmp
Group: System Environment/Kernel
Summary: GFS-kernel-largesmp - The Global File System kernel modules
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-largesmp
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildxen}
%package -n GFS-kernel-xenU
Group: System Environment/Kernel
Summary: GFS-kernel-xenU - The Global File System kernel modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-xenU
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n gfs-kernel-%{version}-%{subversion}
# Put the version information into the necessary files
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
	src/nolock/main.c src/gulm/gulm.h src/gfs/gfs.h src/harness/main.c 
%patch0 -p2
%patch9 -p1

################################################################################
##  THE BUILD SECTION
################################################################################
%build
ROOT_DIR_FILES=`ls`

mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_gfs(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

        ./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers
        make  DLMSYMVERFILE=/lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers
}

%if %{buildup}
cd up
Build_gfs %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_gfs %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_gfs %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_gfs %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_gfs %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}/kernel/cluster/dlm.symvers
cd ..
%endif
 
%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}smp/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}hugemem/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}largesmp/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}xenU/kernel/cluster/dlm.symvers
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}/kernel/fs/gfs/*
/lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*/*

%if %{buildsmp}
%files -n GFS-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*/*
%endif

%if %{buildhugemem}
%files -n GFS-kernel-hugemem
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}hugemem/kernel/fs/gfs/*
/lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking/*/*
%endif

%if %{buildlargesmp}
%files -n GFS-kernel-largesmp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}largesmp/kernel/fs/gfs/*
/lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking/*/*
%endif

%if %{buildxen}
%files -n GFS-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*/*
%endif

%files -n GFS-kernheaders
%defattr(-,root,root,-)
%{_includedir}/linux/*

%changelog
* Fri Jun 29 2007 X/OS Linux Team <xoslinux@xos.nl> 2.6.9-72.2.0.2.XOS.1
- Build for X/OS Linux 4.
- X/OS Linux source rpm based on GFS-kernel-2.6.9-72.2.0.2.src.rpm
  (md5sum of original source rpm: 22b50963717d0cc29b395bf7c914e228).
- Adapt kernel release macro to match X/OS kernel release.
- Fix problem with undefined types in gfs_ondisk.h (bugzilla #239253).

* Fri Jun 08 2007 Chris Feist <cfeist@redhat.com>
- Fixed a problem which can cause inode corruption
- Built for 55.0.2.EL
- Resolves: rhbz#243146 rhbz#244254

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Added support for xenU.

* Wed Dec 20 2006 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-42.0.4.EL kernel

* Mon Apr 24 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provides GFS-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleanup spec file and fix %files section.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Nov 1 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources w/ fix for __you_cannot_kmalloc_that_much

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com> 
- new upstream sources
- smp was building but not being packaged

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com> 
- add patch for make file

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
